summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2020-12-28 15:04:54 +0000
committerPádraig Brady <P@draigBrady.com>2020-12-28 16:21:38 +0000
commitffb7ebfa253a44f52808cade5657d7541eaccfa5 (patch)
treeff9f3cc1c129ec0e0663a92542c94a047916274b
parenta7533917e031125cfcb3076a0dc6b9ad7275f9d2 (diff)
tests: add a test for cksum
* tests/misc/cksum.sh: Test basic operation. * tests/local.mk: Reference the new test.
-rw-r--r--tests/local.mk1
-rwxr-xr-xtests/misc/cksum.sh35
2 files changed, 36 insertions, 0 deletions
diff --git a/tests/local.mk b/tests/local.mk
index 297760cc5..9ba80f96f 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -287,6 +287,7 @@ all_tests = \
tests/misc/basenc.pl \
tests/misc/close-stdout.sh \
tests/misc/chroot-fail.sh \
+ tests/misc/cksum.sh \
tests/misc/comm.pl \
tests/misc/csplit.sh \
tests/misc/csplit-1000.sh \
diff --git a/tests/misc/cksum.sh b/tests/misc/cksum.sh
new file mode 100755
index 000000000..2b4cfca4b
--- /dev/null
+++ b/tests/misc/cksum.sh
@@ -0,0 +1,35 @@
+#!/bin/sh
+# Validate cksum operation
+
+# Copyright (C) 2020 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ cksum printf
+
+returns_ 1 cksum missing || fail=1
+
+{
+ for offset in $(seq -1 6); do
+ env printf $(env printf '\\%03o' $(seq 0 $offset));
+ env printf $(env printf '\\%03o' $(seq 0 255));
+ done
+} > in || framework_failure_
+
+cksum in > out || fail=1
+printf '%s\n' '4097727897 2077 in' > exp || framework_failure_
+compare exp out || fail=1
+
+Exit $fail